;; input stream based on character list

(require-extension test typeclass csv)

(require-library abnf)
(import (only abnf <CoreABNF> 
	      CharLex->CoreABNF
	       <Input> <Token> <CharLex> 
	      Input->Token Token->CharLex make-<Input>
	      ))


(define char-list-<Input>
  (make-<Input> null? car cdr))

(define char-list-<Token>
  (Input->Token char-list-<Input>))

(define char-list-<CharLex>
  (Token->CharLex char-list-<Token>))

(define char-list-<CoreABNF>
  (CharLex->CoreABNF char-list-<CharLex>))


(define char-list-<CSV>
  (CoreABNF->CSV char-list-<CoreABNF> ))


(define pcsv ((make-parser char-list-<CSV>) #\|))
(define-values (fcell _ fcsv) (make-format #\|))

(define (->char-list s)
  (if (string? s) (string->list s) s))

(let ((res (pcsv (->char-list "\"Test \n1\"|Test 2|Test 3\nTest 4|Test 5\n"))))
  (print (map csv-record->list res)))

(test-group "csv parse test"
	    (test
	     `(,(list->csv-record (list "Test \n1" "Test 2" "Test 3"))
	       ,(list->csv-record (list "Test 4" "Test 5" )))
	     (pcsv (->char-list "\"Test \n1\"|Test 2|Test 3\nTest 4|Test 5\n"))))


(test-group "csv format test"
	    (test
	     "Test 1|Test 2|Test 3\r\nTest 4|Test 5\r\n"
	     (fcsv `(,(list->csv-record (list "Test 1" "Test 2" "Test 3"))
		     ,(list->csv-record (list "Test 4" "Test 5" ))))))

(test-exit)
